<?php

class Bt_API {

	private $BT_KEY = "3P3VQDUAmwuiTbNMooDgJ7HydMEcG80Y";  //接口密钥
	private $BT_PANEL = "http://10.0.1.233:8888";	   //面板地址

	//如果希望多台面板，可以在实例化对象时，将面板地址与密钥传入
	public function __construct($bt_panel = null,$bt_key = null){
		if($bt_panel) $this->BT_PANEL = $bt_panel;
		if($bt_key) $this->BT_KEY = $bt_key;
	}

	private function GetKeyData(){
		$now_time = time();
		$p_data = array(
				'request_token'	=>	md5($now_time.''.md5($this->BT_KEY)),
				'request_time'	=>	$now_time
		);
		return $p_data;
	}
	 

	/**
	 * 发起POST请求
	 * @param String $url 目标网填，带http://
	 * @param Array|String $data 欲提交的数据
	 * @return string
	 */
	private function HttpPostCookie($url, $pdata='',$timeout = 60)
	{
		
		$data=$this->GetKeyData();
		if($pdata){
			$data=array_merge($data,$pdata);
		}
		
		//定义cookie保存位置
		$cookie_file='./Runtime/'.md5($this->BT_PANEL).'.cookie';
		if(!file_exists($cookie_file)){
			$fp = fopen($cookie_file,'w+');
			fclose($fp);
		}
		$file=$_FILES['blob'];
		
		if($_FILES['blob']){
			$filename = realpath($_FILES['blob']['tmp_name']);
			$data['blob'] = new CURLFile($filename);
		}
		$ch = curl_init();
		curl_setopt($ch, CURLOPT_URL, $url);
		curl_setopt($ch, CURLOPT_TIMEOUT, $timeout);
		curl_setopt($ch, CURLOPT_POST, 1);
		curl_setopt($ch, CURLOPT_POSTFIELDS, $data);
		curl_setopt($ch, CURLOPT_COOKIEJAR, $cookie_file);
		curl_setopt($ch, CURLOPT_COOKIEFILE, $cookie_file);
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
		curl_setopt($ch, CURLOPT_HEADER, 0);
		curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, false);
		curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
		$output = curl_exec($ch);
		
		curl_close($ch);
		//unlink('./Runtime/'.I('f_name'));
		return $output;
	}
	
	public function btSend($url, $data=''){
		$url=$this->BT_PANEL.$url;
		
		return  $this->HttpPostCookie($url,$data);
	}


	public function curl_custom_postfields($ch, array $assoc = array(), array $files = array()) {
    
		// invalid characters for "name" and "filename"
		static $disallow = array("\0", "\"", "\r", "\n");
		
		// build normal parameters
		foreach ($assoc as $k => $v) {
			$k = str_replace($disallow, "_", $k);
			$body[] = implode("\r\n", array(
				"Content-Disposition: form-data; name=\"{$k}\"",
				"",
				filter_var($v), 
			));
		}
		
		// build file parameters
		foreach ($files as $k => $v) {
			switch (true) {
				case false === $v = realpath(filter_var($v)):
				case !is_file($v):
				case !is_readable($v):
					continue; // or return false, throw new InvalidArgumentException
			}
			$data = file_get_contents($v);
			$v = call_user_func("end", explode(DIRECTORY_SEPARATOR, $v));
			$k = str_replace($disallow, "_", $k);
			$v = str_replace($disallow, "_", $v);
			$body[] = implode("\r\n", array(
				"Content-Disposition: form-data; name=\"{$k}\"; filename=\"{$v}\"",
				"Content-Type: application/octet-stream",
				"",
				$data, 
			));
		}
		
		// generate safe boundary 
		do {
			$boundary = "---------------------" . md5(mt_rand() . microtime());
		} while (preg_grep("/{$boundary}/", $body));
		
		// add boundary for each parameters
		array_walk($body, function (&$part) use ($boundary) {
			$part = "--{$boundary}\r\n{$part}";
		});
		
		// add final boundary
		$body[] = "--{$boundary}--";
		$body[] = "";
		
		// set options
		return @curl_setopt_array($ch, array(
			CURLOPT_POST       => true,
			CURLOPT_POSTFIELDS => implode("\r\n", $body),
			CURLOPT_HTTPHEADER => array(
				"Expect: 100-continue",
				"Content-Type: multipart/form-data; boundary={$boundary}", // change Content-Type
			),
		));
	}
}

/*

	public function GetNetWork(){
		//拼接URL地址
		$url = $this->BT_PANEL.'/system?action=GetNetWork';
	
		//准备POST数据
		$p_data = $this->GetKeyData();		//取签名
	
	
		//请求面板接口
		$result = $this->HttpPostCookie($url,$p_data);
	
		//解析JSON数据
		$data = json_decode($result,true);
		return $data;
	}
	
	//示例取面板日志
	public function GetLogs(){
		//拼接URL地址
		$url = $this->BT_PANEL.'/data?action=getData';
	
		//准备POST数据
		$p_data = $this->GetKeyData();		//取签名
		$p_data['table'] = 'logs';
		$p_data['limit'] = 10;
		$p_data['tojs'] = 'test';
	
		//请求面板接口
		$result = $this->HttpPostCookie($url,$p_data);
	
		//解析JSON数据
		$data = json_decode($result,true);
		return $data;
	}
//实例化对象
$api = new bt_api();
//获取面板日志
//$r_data = $api->GetLogs();
$r_data = $api->GetNetWork();
//输出JSON数据到浏览器
print_r($r_data);
echo json_encode($r_data);
*/

?>